/*
 * SFBTC103Servlet.java
 *
 * Created on September 16, 2003, 1:52 PM
 */
import java.io.*;
import java.util.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;
import javax.ejb.*;
import javax.rmi.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.sun.appserver.tests.ha.sfsb.sfbtc.*;

public class SFBTC103Servlet extends HttpServlet {

   @EJB SFBTC103 sfbtc103bean;

Vector bookList = new Vector();

   public void doGet(HttpServletRequest request, HttpServletResponse response)
        					throws ServletException, IOException
    	{
        	HttpSession httpsession = request.getSession(true);
		PrintWriter out = response.getWriter();
		 out.println("Executed From Instance: <b>"+System.getProperty("com.sun.aas.instanceName") +"</b><br>");


        	out.println("Session Id is : " + httpsession.getId() + "<br>");

		out.println("Is Session new : " + httpsession.isNew() + "<br>");

	        String testName = request.getParameter("test");

		if(testName.equals("create"))
			callCreate(request, response);

		if(testName.equals("getid"))
                        callGetId(request, response);

		if(testName.equals("addbook"))
			callAddBook(request, response);

		if(testName.equals("addbook2"))
                        callAddBook2(request, response);

		if(testName.equals("getbook"))
			callGetBook(request, response);

		if(testName.equals("removebook"))
			callRemoveBook(request, response);

		if(testName.equals("remove")) {
			try{
                        sfbtc103bean.remove();
                        out.println("Bean is removed <br>");
                        System.out.println("Bean is removed ");
                        } catch (Exception re) {
                        out.println("Bean is removed failed <br>");
                        System.out.println("Bean is removed  failed");
                        }
                }

		if(testName.equals("invalidate")) {
			httpsession.invalidate();
			out.println("Session is invalidated <br>\n");
                	System.out.println("Session is invalidated \n");
			}
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
        					throws ServletException, IOException
        {
		doGet(request, response);
        }

// Create bean after getting reference from the httpsession

public void callCreate(HttpServletRequest request, HttpServletResponse response)
                                                                throws IOException
        {
 PrintWriter out=null;

				try {
					HttpSession httpsession = request.getSession(false);
					out = response.getWriter();
					String person = request.getParameter("id");
					if (person == null) {
						sfbtc103bean.setCustomerName("MyFirstBook");
			out.println("Created STATEFUL SESSSION BEAN with id= MyFirstBook");
					}
					httpsession.setAttribute("remoteRef", sfbtc103bean);

                }
                catch(Exception ne)
                {
                        out.println("SFSB creation failed <br>\n");
                        System.out.println("SFSB creation failed \n");
                }
        }



// getId of the bean
public void callGetId(HttpServletRequest request, HttpServletResponse response)
                                                                throws IOException
        {
                HttpSession httpsession = request.getSession(false);
                PrintWriter out = response.getWriter();

                try
                {
			out.println("Get Obj reference of the bean from httpsession: <br>\n");
                        System.out.println("Get Obj reference of the bean from httpsession: \n");

                        sfbtc103bean = (SFBTC103) httpsession.getAttribute("remoteRef");

                        if(sfbtc103bean != null)
                        {
                        out.println("Get Id from the bean <br>\n");
                        System.out.println("Get Id from the bean \n");
                        String id = sfbtc103bean.getId();
                        out.println("Got Id from the bean: " + id + " <BR>\n");
                        System.out.println("Got Id from the bean: " + id );
			} else {
			out.println("Get Obj reference of the bean from httpsession: FAILED<br>");
			System.out.println("Get Obj reference of the bean from httpsession: FAILED\n");
			}
                }
                catch(Exception ne)
                {
                        out.println("getId failed <br>\n");
                        System.out.println("getId failed \n");
                }
        }

// Adding books to the bean
	public void callAddBook(HttpServletRequest request, HttpServletResponse response)
									throws IOException
	{
		HttpSession httpsession = request.getSession(false);
		PrintWriter out = response.getWriter();

		String bookName = request.getParameter("name");

		out.println("addBook to bean: <br> \n");
                System.out.println("addBook to bean: \n");
		try
		{
			out.println("Get Obj reference of the bean from httpsession: <br>\n");
                        System.out.println("Get Obj reference of the bean from httpsession: \n");

                        sfbtc103bean = (SFBTC103) httpsession.getAttribute("remoteRef");

                        if(sfbtc103bean != null)
                        {
				if(bookName==null) {
				sfbtc103bean.addBook("This is my first Book");
				out.println("added :This is my first Book to bean <br> \n");
                		System.out.println("added :This is my first Book to bean  \n");
				} else {
				sfbtc103bean.addBook(bookName);
				out.println("added :" + bookName + " to bean");
				System.out.println("added :" + bookName + " to bean");
				}
			}else {
			out.println("Get Obj reference of the bean from httpsession: FAILED<br>");
                        System.out.println("Get Obj reference of the bean from httpsession: FAILED\n");
                        }

		}
		catch(Exception e)
		{
			out.println("Problem while adding book  <br>\n ");
			System.out.println("Problem while adding book \n ");
		}
	}

//calling addbook2
// Adding books to the bean
        public void callAddBook2(HttpServletRequest request, HttpServletResponse response)
                                                                        throws IOException
        {
                HttpSession httpsession = request.getSession(false);
                PrintWriter out = response.getWriter();

                String bookName = request.getParameter("name");

                out.println("addBook to bean: <br> \n");
                System.out.println("addBook to bean: \n");
                try
                {
                        out.println("Get Obj reference of the bean from httpsession: <br>\n");
                        System.out.println("Get Obj reference of the bean from httpsession: \n");

                        sfbtc103bean = (SFBTC103) httpsession.getAttribute("remoteRef");

                        if(sfbtc103bean != null)
                        {
                                if(bookName==null) {
                                sfbtc103bean.addBook2("This is my 2nd Book");
                                out.println("added :This is my 2nd Book to bean <br> \n");
                                System.out.println("added :This is my 2nd Book to bean  \n");
                                } else {
                                sfbtc103bean.addBook2(bookName);
                                out.println("added :" + bookName + " to bean");
                                System.out.println("added :" + bookName + " to bean");
                                }
                        }else {
                        out.println("Get Obj reference of the bean from httpsession: FAILED<br>");
                        System.out.println("Get Obj reference of the bean from httpsession: FAILED\n");
                        }

                }
                catch(Exception e)
                {
                        out.println("Problem while adding book2  <br>\n ");
                        System.out.println("Problem while adding book2 \n ");
                }
        }

	public void callGetBook(HttpServletRequest request, HttpServletResponse response)
									throws IOException
	{
		HttpSession httpsession = request.getSession(false);
		PrintWriter out = response.getWriter();
		int numBooks=0;
	try
	{
		out.println("GetBooks from bean:  <br>\n");
                System.out.println("GetBooks from bean: \n");

		out.println("Get Obj reference of the bean from httpsession: <br>\n");
                System.out.println("Get Obj reference of the bean from httpsession: \n");
                sfbtc103bean = (SFBTC103) httpsession.getAttribute("remoteRef");
                if(sfbtc103bean != null)
		{
		bookList =  sfbtc103bean.getContents();
		Enumeration enumer = bookList.elements();
			if(enumer.hasMoreElements()==false) {
			out.println("No books found in bean  <br>\n");
                	System.out.println("No books found in bean \n");
			} else {
                		while (enumer.hasMoreElements()) {
                		String title = (String) enumer.nextElement();
				numBooks++;
				out.println(title + "<br>");
                		System.out.println(title);}
				out.println("Number of Books = " + numBooks);
				System.out.println("Number of Books = " + numBooks);
			}
	        } else {
		out.println("Get Obj reference of the bean from httpsession: FAILED<br>");
                System.out.println("Get Obj reference of the bean from httpsession: FAILED\n");
                }
	} catch(Exception e)
		{
		out.println("GetBooks failed <br>\n");
		System.out.println("GetBooks failed \n");
		}
	}

	public void callRemoveBook(HttpServletRequest request, HttpServletResponse response)
									throws IOException
    	{
		HttpSession httpsession = request.getSession(false);
		PrintWriter out = response.getWriter();

		String bookName = request.getParameter("name");

		try
		{
		out.println("removeBook from bean :<br>\n");
                System.out.println("removeBook from bean :\n");
		out.println("Get Obj reference of the bean from httpsession: <br>\n");
                System.out.println("Get Obj reference of the bean from httpsession: \n");
                sfbtc103bean = (SFBTC103) httpsession.getAttribute("remoteRef");
                	if(sfbtc103bean != null)
                	{
				if(bookName==null) {
				sfbtc103bean.removeBook("This is my first Book");
				out.println("removed : This is my first Book from bean<br> \n");
               			System.out.println("removed : This is my first Book from bean \n");
				} else {
				sfbtc103bean.removeBook(bookName);
				out.println("removed :" + bookName + " from bean");
				System.out.println("removed :" + bookName + " from bean");
				}
			} else {
			out.println("Get Obj reference of the bean from httpsession: FAILED<br>");
                	System.out.println("Get Obj reference of the bean from httpsession: FAILED\n");
                	}
		}
		catch(Exception e)
		{
			out.println("removeBook failed <br>\n");
			System.out.println("removeBook failed \n");
		}
    	}
}
