package com.sun.appserver.tests.ha.sfsb.sfbtc;

import javax.ejb.Stateful;
import javax.ejb.EJB;
import javax.ejb.EJBException;
import javax.ejb.SessionContext;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionAttribute;
import javax.naming.InitialContext;
import javax.annotation.Resource;
import javax.transaction.UserTransaction;
import java.util.Vector;
import javax.ejb.Remove;


@Stateful
@TransactionManagement(TransactionManagementType.CONTAINER)
public class SFBTC103Bean implements SFBTC103 {

	String customerName;
	//String customerId;
	Vector contents;

	public void setCustomerName(String name){
		customerName=name;
		contents = new Vector();

	}

        @TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
	public String getId() {
		return customerName;
		}

	@TransactionAttribute(TransactionAttributeType.NEVER) 
	public void addBook(String title) {	
		contents.addElement(title);
	}

	@TransactionAttribute(TransactionAttributeType.NEVER) 
	public void addBook2(String title) {
                contents.addElement(title);
        }

	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public void removeBook(String title) throws Exception {
		boolean result = contents.removeElement(title);
		if (result == false) {
			throw new Exception(title + " not in cart.");
		}
	}

	@TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
	public Vector getContents() {
		return contents;
	}

	@Remove
	public void remove(){
		System.out.println("Bean Removed...");
	}
} 
